# planship-openapi-gen
No description provided (generated by Openapi Generator https://github.com/openapitools/openapi-generator)

This Python package is automatically generated by the [OpenAPI Generator](https://openapi-generator.tech) project:

- API version: 0.1.4
- Package version: 1.0.0
- Build package: org.openapitools.codegen.languages.PythonClientCodegen

## Requirements.

Python 3.7+

## Installation & Usage
### pip install

If the python package is hosted on a repository, you can install directly using:

```sh
pip install git+https://github.com/GIT_USER_ID/GIT_REPO_ID.git
```
(you may need to run `pip` with root permission: `sudo pip install git+https://github.com/GIT_USER_ID/GIT_REPO_ID.git`)

Then import the package:
```python
import planship_openapi_gen
```

### Setuptools

Install via [Setuptools](http://pypi.python.org/pypi/setuptools).

```sh
python setup.py install --user
```
(or `sudo python setup.py install` to install the package for all users)

Then import the package:
```python
import planship_openapi_gen
```

### Tests

Execute `pytest` to run the tests.

## Getting Started

Please follow the [installation procedure](#installation--usage) and then run the following:

```python

import time
import planship_openapi_gen
from planship_openapi_gen.rest import ApiException
from pprint import pprint

# Defining the host is optional and defaults to http://localhost
# See configuration.py for a list of all supported configuration parameters.
configuration = planship_openapi_gen.Configuration(
    host = "http://localhost"
)

# The client must configure the authentication and authorization parameters
# in accordance with the API server security policy.
# Examples for each auth method are provided below, use the example that
# satisfies your auth use case.


# Enter a context with an instance of the API client
with planship_openapi_gen.ApiClient(configuration) as api_client:
    # Create an instance of the API class
    api_instance = planship_openapi_gen.AuthApi(api_client)

    try:
        # Get Access Token
        api_response = api_instance.get_access_token()
        print("The response of AuthApi->get_access_token:\n")
        pprint(api_response)
    except ApiException as e:
        print("Exception when calling AuthApi->get_access_token: %s\n" % e)

```

## Documentation for API Endpoints

All URIs are relative to *http://localhost*

Class | Method | HTTP request | Description
------------ | ------------- | ------------- | -------------
*AuthApi* | [**get_access_token**](docs/AuthApi.md#get_access_token) | **POST** /api/v1/auth/token | Get Access Token
*CustomerSubscriptionsApi* | [**create_plan_subscription_for_customer**](docs/CustomerSubscriptionsApi.md#create_plan_subscription_for_customer) | **POST** /api/v1/customers/{customer_id}/subscriptions | Create Plan Subscription For Customer
*CustomerSubscriptionsApi* | [**get_customer_plan_subscription**](docs/CustomerSubscriptionsApi.md#get_customer_plan_subscription) | **GET** /api/v1/customers/{customer_id}/subscriptions/{subscription_id} | Get Customer Plan Subscription
*CustomerSubscriptionsApi* | [**list_customer_plan_subscriptions**](docs/CustomerSubscriptionsApi.md#list_customer_plan_subscriptions) | **GET** /api/v1/customers/{customer_id}/subscriptions | List Customer Plan Subscriptions
*CustomerSubscriptionsApi* | [**modify_customer_plan_subscription**](docs/CustomerSubscriptionsApi.md#modify_customer_plan_subscription) | **PATCH** /api/v1/customers/{customer_id}/subscriptions/{subscription_id} | Modify Customer Plan Subscription
*CustomersApi* | [**create_customer**](docs/CustomersApi.md#create_customer) | **POST** /api/v1/customers | Create Customer
*CustomersApi* | [**delete_customer**](docs/CustomersApi.md#delete_customer) | **DELETE** /api/v1/customers/{customer_id} | Delete Customer
*CustomersApi* | [**get_customer**](docs/CustomersApi.md#get_customer) | **GET** /api/v1/customers/{customer_id} | Get Customer
*EntitlementsApi* | [**get_product_entitlements_for_customer**](docs/EntitlementsApi.md#get_product_entitlements_for_customer) | **GET** /api/v1/customers/{customer_id}/products/{product_slug}/entitlements | Get Product Entitlements For Customer
*HealthApi* | [**health**](docs/HealthApi.md#health) | **GET** /api/v1/health | Health
*MeteredUsageApi* | [**get_lever_usage_for_customer**](docs/MeteredUsageApi.md#get_lever_usage_for_customer) | **GET** /api/v1/customers/{customer_id}/products/{product_slug}/levers/{lever_slug}/usage | Get Lever Usage For Customer
*MeteredUsageApi* | [**get_metering_id_levers_usage_for_customer**](docs/MeteredUsageApi.md#get_metering_id_levers_usage_for_customer) | **GET** /api/v1/customers/{customer_id}/products/{product_slug}/usage/{metering_id} | Get Metering Id Levers Usage For Customer
*MeteredUsageApi* | [**report_metered_usage_for_customer**](docs/MeteredUsageApi.md#report_metered_usage_for_customer) | **POST** /api/v1/customers/{customer_id}/products/{product_slug}/usage/{metering_id} | Report Metered Usage For Customer
*ProductsApi* | [**create_plan_subscription**](docs/ProductsApi.md#create_plan_subscription) | **POST** /api/v1/products/{product_slug}/plans/{slug}/subscriptions | Create Plan Subscription
*ProductsApi* | [**get_product**](docs/ProductsApi.md#get_product) | **GET** /api/v1/products/{slug} | Get Product
*ProductsApi* | [**get_product_lever**](docs/ProductsApi.md#get_product_lever) | **GET** /api/v1/products/{product_slug}/levers/{slug} | Get Product Lever
*ProductsApi* | [**get_product_plan**](docs/ProductsApi.md#get_product_plan) | **GET** /api/v1/products/{product_slug}/plans/{slug} | Get Product Plan
*ProductsApi* | [**get_product_plan_entitlements**](docs/ProductsApi.md#get_product_plan_entitlements) | **GET** /api/v1/products/{product_slug}/plans/{slug}/entitlements | Get Product Plan Entitlements
*ProductsApi* | [**list_product_levers**](docs/ProductsApi.md#list_product_levers) | **GET** /api/v1/products/{slug}/levers | List Product Levers
*ProductsApi* | [**list_product_plans**](docs/ProductsApi.md#list_product_plans) | **GET** /api/v1/products/{slug}/plans | List Product Plans
*ProductsApi* | [**list_products**](docs/ProductsApi.md#list_products) | **GET** /api/v1/products | List Products
*PublicApi* | [**get_public_plan**](docs/PublicApi.md#get_public_plan) | **GET** /api/v1/public/{organization_slug}/{product_slug}/plans/{plan_slug} | Get Public Plan
*PublicApi* | [**list_public_plans**](docs/PublicApi.md#list_public_plans) | **GET** /api/v1/public/{organization_slug}/{product_slug}/plans | List Public Plans
*SubscriptionCustomersApi* | [**add_customer_to_subscription**](docs/SubscriptionCustomersApi.md#add_customer_to_subscription) | **POST** /api/v1/customers/{customer_id}/subscriptions/{subscription_id}/customers | Add Customer To Subscription
*SubscriptionCustomersApi* | [**list_subscription_customers**](docs/SubscriptionCustomersApi.md#list_subscription_customers) | **GET** /api/v1/customers/{customer_id}/subscriptions/{subscription_id}/customers | List Subscription Customers
*SubscriptionCustomersApi* | [**remove_customer_from_subscription**](docs/SubscriptionCustomersApi.md#remove_customer_from_subscription) | **DELETE** /api/v1/customers/{customer_id}/subscriptions/{subscription_id}/customers/{id} | Remove Customer From Subscription
*SubscriptionsApi* | [**force_renew_subscription**](docs/SubscriptionsApi.md#force_renew_subscription) | **POST** /api/v1/subscriptions/{subscription_id}/renewals | Force Renew Subscription


## Documentation For Models

 - [BucketUsage](docs/BucketUsage.md)
 - [Customer](docs/Customer.md)
 - [CustomerInDbBase](docs/CustomerInDbBase.md)
 - [CustomerSubscriptionWithPlan](docs/CustomerSubscriptionWithPlan.md)
 - [HTTPValidationError](docs/HTTPValidationError.md)
 - [IdNameOrmBase](docs/IdNameOrmBase.md)
 - [IdNameSlugOrmBase](docs/IdNameSlugOrmBase.md)
 - [Lever](docs/Lever.md)
 - [LeverUsage](docs/LeverUsage.md)
 - [LocationInner](docs/LocationInner.md)
 - [MeteredUsageIn](docs/MeteredUsageIn.md)
 - [MeteringRecord](docs/MeteringRecord.md)
 - [OrganizationCustomerCreate](docs/OrganizationCustomerCreate.md)
 - [Plan](docs/Plan.md)
 - [PlanEntitlement](docs/PlanEntitlement.md)
 - [PlanInDbBase](docs/PlanInDbBase.md)
 - [PlanInList](docs/PlanInList.md)
 - [PlanSubscriptionCreate](docs/PlanSubscriptionCreate.md)
 - [Product](docs/Product.md)
 - [SubscriptionCreate](docs/SubscriptionCreate.md)
 - [SubscriptionCustomer](docs/SubscriptionCustomer.md)
 - [SubscriptionCustomerAdd](docs/SubscriptionCustomerAdd.md)
 - [SubscriptionCustomerInDbBase](docs/SubscriptionCustomerInDbBase.md)
 - [SubscriptionUpdateWithSlugs](docs/SubscriptionUpdateWithSlugs.md)
 - [SubscriptionWithPlan](docs/SubscriptionWithPlan.md)
 - [TimeUnits](docs/TimeUnits.md)
 - [TokenResponse](docs/TokenResponse.md)
 - [ValidationError](docs/ValidationError.md)


<a id="documentation-for-authorization"></a>
## Documentation For Authorization


Authentication schemes defined for the API:
<a id="basic"></a>
### basic


<a id="oAuth2ClientCredentials"></a>
### oAuth2ClientCredentials

- **Type**: OAuth
- **Flow**: application
- **Authorization URL**: 
- **Scopes**: 
 - **entitlements:read**: Read entitlements
 - **usage:read**: Read usage
 - **usage:write**: Write usage
 - **subscriptions:read**: Read subscriptions
 - **subscriptions:write**: Create and modify subscriptions
 - **customers:write**: Create and delete customers


## Author




